program Pdb2Txt;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}
{$APPTYPE CONSOLE}
uses
  SysUtils,
  DocFile in 'DocFile.pas',
  PalmDatabase in 'PalmDatabase.pas';

const VERSION = '0.03';

procedure Convert(const FileMask: string; Recursive: boolean);
var SR: TSearchRec;
    OK: integer;
    PDB: TDocFile;
    Dir, Mask: string;
    T: TextFile;
begin
  Dir := ExtractFilePath(FileMask);
  OK := FindFirst(FileMask, faAnyFile, SR);
  if OK = 0 then
    try
      repeat
        if not Longbool(SR.Attr and (faDirectory or faVolumeID)) then
          begin
          Write(Dir + SR.Name + '     ');
          try
            PDB := TDocFile.Create(Dir + SR.Name);
            try
              AssignFile(T, Dir + SR.Name + '.txt');
              Rewrite(T);
              try
                Write(T, PDB.GetDocument);
              finally
                CloseFile(T);
                end;
            finally
              PDB.Free;
              end;
            Writeln('OK');
          except
            on E: Exception do
              Writeln(E.ClassName + ': ' + E.Message);
            end;
          end;
        OK := FindNext(SR);
      until OK <> 0;
    finally
      FindClose(SR);
      end;
  if Recursive then
    begin
    OK := FindFirst(Dir + '*.*', faDirectory, SR);
    Mask := ExtractFileName(FileMask);
    try
      while OK = 0 do
        begin
        if (SR.Name <> '.') and (SR.Name <> '..') then
          Convert(Dir + SR.Name + '\' + Mask, Recursive);
        OK := FindNext(SR);
        end;
    finally
      FindClose(SR);
      end;
    end;
end;


var i: integer;
    Recursive: boolean;
begin
  Writeln('PDB2TXT v' + VERSION);
  Recursive := False;
  if ParamCount = 0 then
    Convert('*.pdb', Recursive)
  else
    for i := 1 to ParamCount do
      if ParamStr(i) = '-r' then
        Recursive := True
      else
        Convert(ParamStr(i), Recursive);
end.
